GNU bug report logs - #48331
Emacs' describe-package doesn't work for packages managed by guix

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: guix; Reported by: Andrew Tropin <andrew@HIDDEN>; dated Mon, 10 May 2021 07:52:02 UTC; Maintainer for guix is bug-guix@HIDDEN.

Message received at 48331 <at> debbugs.gnu.org:


Received: (at 48331) by debbugs.gnu.org; 20 May 2021 12:24:59 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 20 08:24:59 2021
Received: from localhost ([127.0.0.1]:33297 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ljhjX-00041x-3Y
	for submit <at> debbugs.gnu.org; Thu, 20 May 2021 08:24:59 -0400
Received: from mail-qt1-f180.google.com ([209.85.160.180]:39623)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <andrew@HIDDEN>) id 1ljhjT-00041b-VT
 for 48331 <at> debbugs.gnu.org; Thu, 20 May 2021 08:24:57 -0400
Received: by mail-qt1-f180.google.com with SMTP id f8so12565004qth.6
 for <48331 <at> debbugs.gnu.org>; Thu, 20 May 2021 05:24:55 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=trop-in.20150623.gappssmtp.com; s=20150623;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=6f8mk1d06+Xcc69xOQKFc/Uher7BnPgzenrAqoNZjas=;
 b=bQTlPBihlhzhUldwH3JHwWBdkCvBUEvy+3+ht827oNRam06GybOCIUSkHPCDu9bG3W
 04hgRwMbDBJXLbtxxk3nXCnhJH2sfm6AJGJ9ryuijNuKNi4+lDENCtDkuUPVc3T1c7MJ
 +JDWko1geKB+NMh5RrLzbOrcnKAtLfVqatMApDMwoe5yLVs/yzykIfrx2GM2hhbW67IJ
 25hKxOWdLK4vcQpyvq/de7hSIJ55+fFSs6qBZmbOqJRA0wuD6WEeCEgArNmi2REaog7J
 6sx88ZcX+12MG4hs6XJZU+0DdKBHUgG1J6xrNt3fXVpEZs1fIdjFIOUSTd/K9YykN6cS
 LkQw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=6f8mk1d06+Xcc69xOQKFc/Uher7BnPgzenrAqoNZjas=;
 b=iIFWYuSBoG/bdB5vnKpyxzB2EYPFdqIpGD77PcclyLRhRIXnPEOeQfC5AhipS262Pf
 q4Z1zLXJDXKSiiIrTxq0AyHxwic+YUj4uErEjkjOLyg+FESWpfGFKd0yOIDLyhwMLrFh
 njTILw6vtMZBuvfTpLFYLML9VwnK903mDZJuLlKOawNJdPQ6Wf21Cgx4Eicmn22mJnaQ
 2kz+SFW4H1yya1Og1uV4LjDvNYD284N5TSepPG3RPbGxlUDt7P1oGE9wjAZlBkXp9hlM
 J3masoTJ/M6aIItkZVqkEhawmPT7siFaPf82/9y9z9IGhcmEGf1XbhHlB1UgR+0bCmTp
 jl2A==
X-Gm-Message-State: AOAM532olNDq6ZGhWjj3VBn2hMxDyN42D6iAqNTAEo1KLJs4OJofnvws
 4fCu75mAZTpafj+cEiQVjuY7g5MjWqXlZra2j/2agg==
X-Google-Smtp-Source: ABdhPJzzr7hvxsuZgGuKEKb3bJyAfId/GV7F37+Hwh4fvd5y7EkUMrw636JWkg6oihMyPJCVUTWYwzgZaRd1CAg/2L8=
X-Received: by 2002:ac8:5ac7:: with SMTP id d7mr4718420qtd.173.1621513490459; 
 Thu, 20 May 2021 05:24:50 -0700 (PDT)
MIME-Version: 1.0
References: <87im3r81so.fsf@HIDDEN>
 <78cfb495305fb1137da26e37a7ae5dd9467043bf.camel@HIDDEN>
 <CABrWRW3bRnP+vMu6j73o=p2GHbOsLQ-2MejDV5bCNFuqLDD9Sw@HIDDEN>
 <8164abe40ec6e865bf8385e010702cfe158dabcc.camel@HIDDEN>
 <CABrWRW1WfF0J=Pe1E-R2fyx7f6+qLPMs9nj5C2_ZS-G2SZ5bGQ@HIDDEN>
 <6cba9730ace19ecebc397023b243cdb02486cc0c.camel@HIDDEN>
 <CABrWRW1ZYToRkrwVA5t0J3oz9X-tjF3mEyD_GfusDneV1p_9EQ@HIDDEN>
 <437d90a3cc91400fdf0828fea2c989c277a73a7c.camel@HIDDEN>
 <CABrWRW2OpFaJU-Wz19-smz3OkMx79+rX2WT-N_ZuHkD_Mu6ghQ@HIDDEN>
 <88a438a74fabe0f4d4bfd8a649c38e960ef82ed2.camel@HIDDEN>
 <87tumxzoey.fsf@HIDDEN>
In-Reply-To: <87tumxzoey.fsf@HIDDEN>
From: Andrew Tropin <andrew@HIDDEN>
Date: Thu, 20 May 2021 15:24:39 +0300
Message-ID: <CABrWRW30RRCGOo=tDGf0nObFjLPW40amQQNZBioMVBohar2iaA@HIDDEN>
Subject: Re: Emacs' describe-package doesn't work for packages managed by guix
To: Arun Isaac <arunisaac@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 48331
Cc: Leo Prikler <leo.prikler@HIDDEN>, 48331 <at> debbugs.gnu.org,
 Maxim Cournoyer <maxim.cournoyer@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

> > In other words, no particular thought was given to -pkg.el. It was
> > simply dropped along with many other files. So, if consensus is
> > reachedthat keeping -pkg.el is a good idea, there is no reason to not
> > do that.
> Thanks for clearing that up.  In that case, I don't have any qualms
> about including them either.

Cool, seems we can get -pkg.el files back.

> Multi-profile Emacs should be supported, but this also breaks on
> foreign distros with foreign distro ELPA.  Again, hacking variables is
> not the solution (and even if it was, it'd be better to patch the emacs
> default value, not that this is a good idea either).

Yep, the last snippet supports multi-profile Emacs.  Installing packages
for Emacs via a few different package manager sounds like a very bad
practice) I agree that current implementation with updating variables
isn't perfect and it doesn't cover the use case, which I expect to be
rare (packages from Guix will be listed in list-packages, files from
foreign distro PM won't).  I can dive into package.el implementation and
spend some time next week providing a different workaround.

BTW, can you remind me why we do not place packages under
site-lisp/elpa/NAME-VERSION? It seems almost the same as
site-lisp/NAME-VERSION, but everything related to describe-package and
other functions will work out of the box.  This way it will work even
with a foreign distro use case.




Information forwarded to bug-guix@HIDDEN:
bug#48331; Package guix. Full text available.

Message received at 48331 <at> debbugs.gnu.org:


Received: (at 48331) by debbugs.gnu.org; 20 May 2021 11:13:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 20 07:13:49 2021
Received: from localhost ([127.0.0.1]:33214 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ljgcf-0008Nv-14
	for submit <at> debbugs.gnu.org; Thu, 20 May 2021 07:13:49 -0400
Received: from mailrelay.tugraz.at ([129.27.2.202]:51760)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <leo.prikler@HIDDEN>) id 1ljgcc-0008Nl-T9
 for 48331 <at> debbugs.gnu.org; Thu, 20 May 2021 07:13:47 -0400
Received: from [10.0.0.4] (91-114-247-246.adsl.highway.telekom.at
 [91.114.247.246])
 by mailrelay.tugraz.at (Postfix) with ESMTPSA id 4Fm6Yf42WLz3x7T;
 Thu, 20 May 2021 13:13:42 +0200 (CEST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=tugraz.at;
 s=mailrelay; t=1621509222;
 bh=vP21ZXboBlrPTi/kSEEoLkOWbF+ezRDbh2PFrleMpSk=;
 h=Subject:From:To:Cc:Date:In-Reply-To:References;
 b=sllVNXqo42NDQmA8ae9cQge63mH+sVDGu6J08/JNIlm2uAawVrO6V4K5InF/a/IRK
 pt64ZonDfHrMSluKujJC4zi4NQNGcDgjgoW3ry3UaHiaEazC6hfHlD8/CQX4O35QCO
 zerC9rRdpABLpopIejEP7yyhurELKWuTa+QECBbY=
Message-ID: <681fe5a3db7bcff56fa20e2124c2cb5276fc5eb0.camel@HIDDEN>
Subject: Re: bug#48331: Emacs' describe-package doesn't work for packages
 managed by guix
From: Leo Prikler <leo.prikler@HIDDEN>
To: Arun Isaac <arunisaac@HIDDEN>, Andrew Tropin <andrew@HIDDEN>
Date: Thu, 20 May 2021 13:13:21 +0200
In-Reply-To: <87r1i1zo2w.fsf@HIDDEN>
References: <87im3r81so.fsf@HIDDEN>
 <78cfb495305fb1137da26e37a7ae5dd9467043bf.camel@HIDDEN>
 <CABrWRW3bRnP+vMu6j73o=p2GHbOsLQ-2MejDV5bCNFuqLDD9Sw@HIDDEN>
 <8164abe40ec6e865bf8385e010702cfe158dabcc.camel@HIDDEN>
 <CABrWRW1WfF0J=Pe1E-R2fyx7f6+qLPMs9nj5C2_ZS-G2SZ5bGQ@HIDDEN>
 <6cba9730ace19ecebc397023b243cdb02486cc0c.camel@HIDDEN>
 <CABrWRW1ZYToRkrwVA5t0J3oz9X-tjF3mEyD_GfusDneV1p_9EQ@HIDDEN>
 <437d90a3cc91400fdf0828fea2c989c277a73a7c.camel@HIDDEN>
 <CABrWRW2OpFaJU-Wz19-smz3OkMx79+rX2WT-N_ZuHkD_Mu6ghQ@HIDDEN>
 <88a438a74fabe0f4d4bfd8a649c38e960ef82ed2.camel@HIDDEN>
 <87tumxzoey.fsf@HIDDEN> <87r1i1zo2w.fsf@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
User-Agent: Evolution 3.34.2 
MIME-Version: 1.0
Content-Transfer-Encoding: 7bit
X-TUG-Backscatter-control: bt4lQm5Tva3SBgCuw0EnZw
X-Spam-Scanner: SpamAssassin 3.003001 
X-Spam-Score-relay: -1.9
X-Scanned-By: MIMEDefang 2.74 on 129.27.10.117
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 48331
Cc: 48331 <at> debbugs.gnu.org, Maxim Cournoyer <maxim.cournoyer@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Am Donnerstag, den 20.05.2021, 16:09 +0530 schrieb Arun Isaac:
> > > [Adding Arun Isaac to CC.  Their commit d8796851 is the first one
> > > to
> > > drop -pkg.el, but without explanation.]
> > 
> > Commit d8796851 was an attempt to not install too many unnecessary
> > files
> > and be closer to how MELPA packaged emacs packages. See
> > https://lists.gnu.org/archive/html/guix-devel/2017-04/msg00274.html
> >  for
> > the detailed discussion.
> 
> In other words, no particular thought was given to -pkg.el. It was
> simply dropped along with many other files. So, if consensus is
> reachedthat keeping -pkg.el is a good idea, there is no reason to not
> do that.
Thanks for clearing that up.  In that case, I don't have any qualms
about including them either.

Cheers!





Information forwarded to bug-guix@HIDDEN:
bug#48331; Package guix. Full text available.

Message received at 48331 <at> debbugs.gnu.org:


Received: (at 48331) by debbugs.gnu.org; 20 May 2021 10:39:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 20 06:39:46 2021
Received: from localhost ([127.0.0.1]:33191 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ljg5i-0007XO-Jp
	for submit <at> debbugs.gnu.org; Thu, 20 May 2021 06:39:46 -0400
Received: from mugam.systemreboot.net ([139.59.75.54]:36864)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <arunisaac@HIDDEN>) id 1ljg5g-0007XF-GA
 for 48331 <at> debbugs.gnu.org; Thu, 20 May 2021 06:39:45 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed;
 d=systemreboot.net; s=default; h=Content-Type:MIME-Version:Message-ID:Date:
 References:In-Reply-To:Subject:Cc:To:From:Sender:Reply-To:
 Content-Transfer-Encoding:Content-ID:Content-Description:Resent-Date:
 Resent-From:Resent-Sender:Resent-To:Resent-Cc:Resent-Message-ID:List-Id:
 List-Help:List-Unsubscribe:List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=rtyjlrewDfdhW2t3UtNIe5AWlSw5RzwEYg0FUGBOx00=; b=Uh+6EVX1+jrOIuSnNnyXz8X4+
 p5t3uaYZqYGzdWPFwuQI+206LuKSKd0JPjvNovrkOd2MioR18jHWYjuZXYz2RnTfKXRjvukrT3ujI
 TluwRGJ1xme80sJbTgiLaHqVXZR7sh70SI77QnAHx8mK4L8Rltboz6Z6aidobtkR32c5OC2iYcFsV
 mFtdevIu3PuVdUx9mu/ikyWNtCwKP6lr5WUZFBucCRtmS8Z02iNoyHlfjBDtUeJw/LPC0ybE2KOIX
 ZtTRG3CkLuhSQJ5PoEl9YLNKylkNzxh9mXiu6QeO92ERruFdL6CTNfVhk/TLOUZnca0jjLOSlM5YV
 4ikqZhNoA==;
Received: from [192.168.2.1] (helo=steel)
 by systemreboot.net with esmtpsa (TLS1.3) tls
 TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384 (Exim 4.94)
 (envelope-from <arunisaac@HIDDEN>)
 id 1ljg5X-000nHu-6b; Thu, 20 May 2021 16:09:35 +0530
From: Arun Isaac <arunisaac@HIDDEN>
To: Leo Prikler <leo.prikler@HIDDEN>, Andrew Tropin <andrew@HIDDEN>
Subject: Re: bug#48331: Emacs' describe-package doesn't work for packages
 managed by guix
In-Reply-To: <87tumxzoey.fsf@HIDDEN>
References: <87im3r81so.fsf@HIDDEN>
 <78cfb495305fb1137da26e37a7ae5dd9467043bf.camel@HIDDEN>
 <CABrWRW3bRnP+vMu6j73o=p2GHbOsLQ-2MejDV5bCNFuqLDD9Sw@HIDDEN>
 <8164abe40ec6e865bf8385e010702cfe158dabcc.camel@HIDDEN>
 <CABrWRW1WfF0J=Pe1E-R2fyx7f6+qLPMs9nj5C2_ZS-G2SZ5bGQ@HIDDEN>
 <6cba9730ace19ecebc397023b243cdb02486cc0c.camel@HIDDEN>
 <CABrWRW1ZYToRkrwVA5t0J3oz9X-tjF3mEyD_GfusDneV1p_9EQ@HIDDEN>
 <437d90a3cc91400fdf0828fea2c989c277a73a7c.camel@HIDDEN>
 <CABrWRW2OpFaJU-Wz19-smz3OkMx79+rX2WT-N_ZuHkD_Mu6ghQ@HIDDEN>
 <88a438a74fabe0f4d4bfd8a649c38e960ef82ed2.camel@HIDDEN>
 <87tumxzoey.fsf@HIDDEN>
Date: Thu, 20 May 2021 16:09:19 +0530
Message-ID: <87r1i1zo2w.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 48331
Cc: 48331 <at> debbugs.gnu.org, Maxim Cournoyer <maxim.cournoyer@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain


>> [Adding Arun Isaac to CC.  Their commit d8796851 is the first one to
>> drop -pkg.el, but without explanation.]
>
> Commit d8796851 was an attempt to not install too many unnecessary files
> and be closer to how MELPA packaged emacs packages. See
> https://lists.gnu.org/archive/html/guix-devel/2017-04/msg00274.html for
> the detailed discussion.

In other words, no particular thought was given to -pkg.el. It was
simply dropped along with many other files. So, if consensus is reached
that keeping -pkg.el is a good idea, there is no reason to not do that.

Cheers!

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQFPBAEBCAA5FiEEf3MDQ/Lwnzx3v3nTLiXui2GAK7MFAmCmPFcbHGFydW5pc2Fh
Y0BzeXN0ZW1yZWJvb3QubmV0AAoJEC4l7othgCuzZBsIAL332OS6wbQQWXOXnku8
ejyDzp8enbrx0aV3DPjuicsY5EEsPiL2R4+iVTe44RRYT+qlRg7m3iBBWyCTWlh7
VZH0+shMpAr+2oiaZYhcZSv3PlFJMuGNx/6Ny8hOqYhZgMwsFjxI/CuBuqhbgspZ
1TqtP95gV7QquLJnZ3fAlyPznaC53ibeG2R7pPL2LwklNaQ60AUYqffZd8Gatv6K
VN9/cCD3Bfll+B1qCCh+BKQFTzLlN02pnIIYuKIEYNOTXCOtCC8hWu01Tx08aReL
ZwAiHFgHmx68uFu4XblUQhk7KNYdVSCBLhXE4hJ2A6MJcznkWzAAH3gfaDtaazDp
GYI=
=B1+W
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-guix@HIDDEN:
bug#48331; Package guix. Full text available.

Message received at 48331 <at> debbugs.gnu.org:


Received: (at 48331) by debbugs.gnu.org; 20 May 2021 10:32:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 20 06:32:47 2021
Received: from localhost ([127.0.0.1]:33187 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ljfyw-0007Nh-Sb
	for submit <at> debbugs.gnu.org; Thu, 20 May 2021 06:32:47 -0400
Received: from mugam.systemreboot.net ([139.59.75.54]:36848)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <arunisaac@HIDDEN>) id 1ljfyt-0007NT-Gq
 for 48331 <at> debbugs.gnu.org; Thu, 20 May 2021 06:32:45 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed;
 d=systemreboot.net; s=default; h=Content-Type:MIME-Version:Message-ID:Date:
 References:In-Reply-To:Subject:Cc:To:From:Sender:Reply-To:
 Content-Transfer-Encoding:Content-ID:Content-Description:Resent-Date:
 Resent-From:Resent-Sender:Resent-To:Resent-Cc:Resent-Message-ID:List-Id:
 List-Help:List-Unsubscribe:List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=fjupa7a8w9HiY+JC8j5jHwP2bZWZ+C182ixjl7m3Elc=; b=nccxVSA/eF77Ry/Sv8TwlcBqY
 0sIAGxDEjGQro0nWCJ+/wK6Hz0DG6vpH43Yf/R3rYLJQ6iLPsJ+x0EWYRVpTHh2nA2jgGyUt8hXL6
 g5ddSvRCH0onh8bBhUteET35VDcTSs3NiY5L1+wBYYfK+T6wjcYxl2nLsejhln4jizWleOd0pTukP
 pB4nFFvY3RczUCwRVPOfecyapiu0xLe0vzSnxWPftGrmqvAc7ORdxBW7pftHL4E3kVYuoNWsrv+jv
 NVqr8U3zBcpmI5TwhVPs36QTEHTjKK8Z+u/J/STm3yCEWXRBVBg9tIWZDOT3R+blBy5GNWwHIBTkd
 rnp98mIdg==;
Received: from [192.168.2.1] (helo=steel)
 by systemreboot.net with esmtpsa (TLS1.3) tls
 TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384 (Exim 4.94)
 (envelope-from <arunisaac@HIDDEN>)
 id 1ljfyc-000nGg-OC; Thu, 20 May 2021 16:02:26 +0530
From: Arun Isaac <arunisaac@HIDDEN>
To: Leo Prikler <leo.prikler@HIDDEN>, Andrew Tropin <andrew@HIDDEN>
Subject: Re: Emacs' describe-package doesn't work for packages managed by guix
In-Reply-To: <88a438a74fabe0f4d4bfd8a649c38e960ef82ed2.camel@HIDDEN>
References: <87im3r81so.fsf@HIDDEN>
 <78cfb495305fb1137da26e37a7ae5dd9467043bf.camel@HIDDEN>
 <CABrWRW3bRnP+vMu6j73o=p2GHbOsLQ-2MejDV5bCNFuqLDD9Sw@HIDDEN>
 <8164abe40ec6e865bf8385e010702cfe158dabcc.camel@HIDDEN>
 <CABrWRW1WfF0J=Pe1E-R2fyx7f6+qLPMs9nj5C2_ZS-G2SZ5bGQ@HIDDEN>
 <6cba9730ace19ecebc397023b243cdb02486cc0c.camel@HIDDEN>
 <CABrWRW1ZYToRkrwVA5t0J3oz9X-tjF3mEyD_GfusDneV1p_9EQ@HIDDEN>
 <437d90a3cc91400fdf0828fea2c989c277a73a7c.camel@HIDDEN>
 <CABrWRW2OpFaJU-Wz19-smz3OkMx79+rX2WT-N_ZuHkD_Mu6ghQ@HIDDEN>
 <88a438a74fabe0f4d4bfd8a649c38e960ef82ed2.camel@HIDDEN>
Date: Thu, 20 May 2021 16:02:05 +0530
Message-ID: <87tumxzoey.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 48331
Cc: 48331 <at> debbugs.gnu.org, Maxim Cournoyer <maxim.cournoyer@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain


> [Adding Arun Isaac to CC.  Their commit d8796851 is the first one to
> drop -pkg.el, but without explanation.]

Commit d8796851 was an attempt to not install too many unnecessary files
and be closer to how MELPA packaged emacs packages. See
https://lists.gnu.org/archive/html/guix-devel/2017-04/msg00274.html for
the detailed discussion.

Cheers!

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQFPBAEBCAA5FiEEf3MDQ/Lwnzx3v3nTLiXui2GAK7MFAmCmOqUbHGFydW5pc2Fh
Y0BzeXN0ZW1yZWJvb3QubmV0AAoJEC4l7othgCuzA1wH/0C6jGDkwLFVUib+44r/
bRlzRgC+SGjJmvHZPgvPiPBTSvTvvUae2zeIhju5yQYafTZg96/W8uqyeh/LbmVJ
9L1wBgxze8otsQVHcCsisPk/YcN1fJtsr59rWo6oEmjcoJyo7NwS6lntPyR2KCcN
oNcARvrQDSY+2IuTgzlQq/zzgip4S2Ph3xR3qDJJuu+4KEszX8CMNZpNdHdvqZrh
GeyuZJo3LvkCst6sUjRC5tdn2oK6ETVdonz8Dr4FItMnwEWAhkFe94bV39bx5wBm
DMbQYCEuTJi5A1VbXcBFgrwnF8Zx7vIF1wTttfcd56upa90FeSPDvcqnxjnjCE+X
PaE=
=1WMU
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-guix@HIDDEN:
bug#48331; Package guix. Full text available.

Message received at 48331 <at> debbugs.gnu.org:


Received: (at 48331) by debbugs.gnu.org; 20 May 2021 10:21:12 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 20 06:21:12 2021
Received: from localhost ([127.0.0.1]:33181 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ljfnk-0006vQ-8I
	for submit <at> debbugs.gnu.org; Thu, 20 May 2021 06:21:12 -0400
Received: from mailrelay.tugraz.at ([129.27.2.202]:54915)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <leo.prikler@HIDDEN>) id 1ljfng-0006vD-PR
 for 48331 <at> debbugs.gnu.org; Thu, 20 May 2021 06:21:10 -0400
Received: from [10.0.0.4] (91-114-247-246.adsl.highway.telekom.at
 [91.114.247.246])
 by mailrelay.tugraz.at (Postfix) with ESMTPSA id 4Fm5Nv6ZFsz3x6y;
 Thu, 20 May 2021 12:21:03 +0200 (CEST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=tugraz.at;
 s=mailrelay; t=1621506064;
 bh=hc0kpX1iA/xRFOgtmy7Irz3xvm6KqRVa3iaHjAjYWQg=;
 h=Subject:From:To:Cc:Date:In-Reply-To:References;
 b=FWmJ5gnXQoS16ygN4xqU0KL6dXtF9ebN/UdGg45r/Cw+VEvzph8PpfzYIMZpZNKQq
 F8LrQHRbzIiMbQaMKS2Zjn1V4MKri6K7zCBDVNr7ioKFWSQbZ5kpMojgGtorNtuRzb
 mfxGftM8UuF8goItw0gBKhPnSPdkaXieHgG0I0Wk=
Message-ID: <43c4f2959e4805aae7414d0acc08f1fd7b35d986.camel@HIDDEN>
Subject: Re: Emacs' describe-package doesn't work for packages managed by guix
From: Leo Prikler <leo.prikler@HIDDEN>
To: Andrew Tropin <andrew@HIDDEN>
Date: Thu, 20 May 2021 12:20:38 +0200
In-Reply-To: <CABrWRW1DiStRz7_OTwixUH9sqcOvjJcx8Big1hmepmQWTMgdSg@HIDDEN>
References: <87im3r81so.fsf@HIDDEN>
 <78cfb495305fb1137da26e37a7ae5dd9467043bf.camel@HIDDEN>
 <CABrWRW3bRnP+vMu6j73o=p2GHbOsLQ-2MejDV5bCNFuqLDD9Sw@HIDDEN>
 <8164abe40ec6e865bf8385e010702cfe158dabcc.camel@HIDDEN>
 <CABrWRW1WfF0J=Pe1E-R2fyx7f6+qLPMs9nj5C2_ZS-G2SZ5bGQ@HIDDEN>
 <6cba9730ace19ecebc397023b243cdb02486cc0c.camel@HIDDEN>
 <CABrWRW1ZYToRkrwVA5t0J3oz9X-tjF3mEyD_GfusDneV1p_9EQ@HIDDEN>
 <437d90a3cc91400fdf0828fea2c989c277a73a7c.camel@HIDDEN>
 <CABrWRW2OpFaJU-Wz19-smz3OkMx79+rX2WT-N_ZuHkD_Mu6ghQ@HIDDEN>
 <88a438a74fabe0f4d4bfd8a649c38e960ef82ed2.camel@HIDDEN>
 <CABrWRW1DiStRz7_OTwixUH9sqcOvjJcx8Big1hmepmQWTMgdSg@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
User-Agent: Evolution 3.34.2 
MIME-Version: 1.0
Content-Transfer-Encoding: 7bit
X-TUG-Backscatter-control: bt4lQm5Tva3SBgCuw0EnZw
X-Spam-Scanner: SpamAssassin 3.003001 
X-Spam-Score-relay: -1.9
X-Scanned-By: MIMEDefang 2.74 on 129.27.10.117
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 48331
Cc: Arun Isaac <arunisaac@HIDDEN>, 48331 <at> debbugs.gnu.org,
 Maxim Cournoyer <maxim.cournoyer@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Am Donnerstag, den 20.05.2021, 13:01 +0300 schrieb Andrew Tropin:
> > That looks like it'd mess with people's installed ELPA
> > packages.  In general, hacks based on package-directory-list don't
> > feel very stable.
> 
> If you talk about ~/.emacs.d/elpa, it won't, because there is a
> separate package-user-dir variable for that.
> 
> The problem can arise if we have emacs installed in a few profiles,
> I'm not sure if it is a good idea to do so, but it is possible, in
> such a case we will have a few items in the package-directory-
> list.  A fix for that:
> 
> (setq package-directory-list
>       (mapcar (apply-partially 'string-remove-suffix "/elpa")
>               package-directory-list)))
Multi-profile Emacs should be supported, but this also breaks on
foreign distros with foreign distro ELPA.  Again, hacking variables is
not the solution (and even if it was, it'd be better to patch the emacs
default value, not that this is a good idea either).

> > Also, this seems to rely on us not deleting the -pkg.el, but
> > probably won't work for packages, that don't ship it, e.g. emacs-
> > howm.
> 
> It's true, but it seems relatively easy to implement a build phase,
> which will generate -pgk.el in case it is missing.
Generating our own -pkg.el should work, still waiting for Maxim or Arun
on a statement as to why we exclude it.

*Always* generating a -pkg.el (disregarding the upstream one if it
exists) might further be a reasonable thing to do if we decide, that
those -pkg.el files are useful.

Regards,
Leo





Information forwarded to bug-guix@HIDDEN:
bug#48331; Package guix. Full text available.

Message received at 48331 <at> debbugs.gnu.org:


Received: (at 48331) by debbugs.gnu.org; 20 May 2021 10:02:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 20 06:02:06 2021
Received: from localhost ([127.0.0.1]:33162 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ljfVG-0006MZ-Mu
	for submit <at> debbugs.gnu.org; Thu, 20 May 2021 06:02:06 -0400
Received: from mail-qt1-f179.google.com ([209.85.160.179]:45957)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <andrew@HIDDEN>) id 1ljfVF-0006M4-CA
 for 48331 <at> debbugs.gnu.org; Thu, 20 May 2021 06:02:05 -0400
Received: by mail-qt1-f179.google.com with SMTP id h24so899362qtm.12
 for <48331 <at> debbugs.gnu.org>; Thu, 20 May 2021 03:02:05 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=trop-in.20150623.gappssmtp.com; s=20150623;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=MTrnHB4nrQIwL8gSGAhbRx/dH9570Fz0ISRiz17D9Aw=;
 b=tDN/SYDg4YQMn657C115XxWRYrMxFoDExrdFkeT5sy7zUw9LyX8JGTivyTzjqWtThl
 udyd2FhN2zGBFyKba9jAr5cCBz8qT1su93dcrLHYWGvZnmfFfaPe12AnHD/SO/el1aUi
 lwtTnXwlI3Ym3lziycerqfOWX4SFdZkNs64qSu4PtyGa8PWJSEvQl0NqCbyG2Md6ChsC
 agkHEQ5eWYP3wYfuomeuNPnbV7Qqjvqec4s4KaGoiUtOMGOxgx4xu/sATE+Ztm7mEbPj
 SqW7B+Zy1/IXt0fIdCaCCrjF6TCccWbmxCTGEHAwhg9aLWWq0XQ/lfKq6b8bGU9Q7Foq
 n1ug==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=MTrnHB4nrQIwL8gSGAhbRx/dH9570Fz0ISRiz17D9Aw=;
 b=U0ri4BocEoyU39w/JmxOCYj4neJW0od0IKvNsr0K+IEvMeBselsDmP8RL/y7bwNKs5
 e8ZaxSg7G5CO6Uio98t9bTSlcuHG5M6THLY5dBW63rU359i3J1AMW+iEBef8BU7vvOot
 eBj2YF0IbSmJjxWelNXus9qagIKyYqrOLixaeTTY7B6tqXjP+o0BNxrQZNDAg1nnQEoQ
 npC6yIcdweGw81eTjM4V6h1DOiiNkrbtnNW4DytTIi4t9lzQ+GeqX1hkLKyMIm7GApiF
 k+6fzep98OcYuf4bHmQqkIasQ9VEEiBlwYgmO9ILf+cWExLMV8H/VDZrMAMA2V+I2o3v
 nohA==
X-Gm-Message-State: AOAM532d/2lUa0+wPnR5oryBlewM8cK7Hqb4qMmrNkT8jFACGHhxCkUo
 ryC0eCURT4pAFYC+5WiEIRTla6h4OH3Im7Ej3pI0Tw==
X-Google-Smtp-Source: ABdhPJzvHQ4Vjm+/2/FksuiCiWjp9rUixwBuJGBFxr80jAKGZsshp05YCLy4pyTl65fnQ3SMzJGY6Jlx+nPH/tUmm/4=
X-Received: by 2002:ac8:45d2:: with SMTP id e18mr4200360qto.374.1621504919725; 
 Thu, 20 May 2021 03:01:59 -0700 (PDT)
MIME-Version: 1.0
References: <87im3r81so.fsf@HIDDEN>
 <78cfb495305fb1137da26e37a7ae5dd9467043bf.camel@HIDDEN>
 <CABrWRW3bRnP+vMu6j73o=p2GHbOsLQ-2MejDV5bCNFuqLDD9Sw@HIDDEN>
 <8164abe40ec6e865bf8385e010702cfe158dabcc.camel@HIDDEN>
 <CABrWRW1WfF0J=Pe1E-R2fyx7f6+qLPMs9nj5C2_ZS-G2SZ5bGQ@HIDDEN>
 <6cba9730ace19ecebc397023b243cdb02486cc0c.camel@HIDDEN>
 <CABrWRW1ZYToRkrwVA5t0J3oz9X-tjF3mEyD_GfusDneV1p_9EQ@HIDDEN>
 <437d90a3cc91400fdf0828fea2c989c277a73a7c.camel@HIDDEN>
 <CABrWRW2OpFaJU-Wz19-smz3OkMx79+rX2WT-N_ZuHkD_Mu6ghQ@HIDDEN>
 <88a438a74fabe0f4d4bfd8a649c38e960ef82ed2.camel@HIDDEN>
In-Reply-To: <88a438a74fabe0f4d4bfd8a649c38e960ef82ed2.camel@HIDDEN>
From: Andrew Tropin <andrew@HIDDEN>
Date: Thu, 20 May 2021 13:01:48 +0300
Message-ID: <CABrWRW1DiStRz7_OTwixUH9sqcOvjJcx8Big1hmepmQWTMgdSg@HIDDEN>
Subject: Re: Emacs' describe-package doesn't work for packages managed by guix
To: Leo Prikler <leo.prikler@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 48331
Cc: Arun Isaac <arunisaac@HIDDEN>, 48331 <at> debbugs.gnu.org,
 Maxim Cournoyer <maxim.cournoyer@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

> That looks like it'd mess with people's installed ELPA packages.  In
> general, hacks based on package-directory-list don't feel very stable.

If you talk about ~/.emacs.d/elpa, it won't, because there is a separate
package-user-dir variable for that.

The problem can arise if we have emacs installed in a few profiles, I'm
not sure if it is a good idea to do so, but it is possible, in such a case
we will have a few items in the package-directory-list.  A fix for that:

(setq package-directory-list
      (mapcar (apply-partially 'string-remove-suffix "/elpa")
              package-directory-list)))

> Also, this seems to rely on us not deleting the -pkg.el, but probably
> won't work for packages, that don't ship it, e.g. emacs-howm.

It's true, but it seems relatively easy to implement a build phase,
which will generate -pgk.el in case it is missing.




Information forwarded to bug-guix@HIDDEN:
bug#48331; Package guix. Full text available.

Message received at 48331 <at> debbugs.gnu.org:


Received: (at 48331) by debbugs.gnu.org; 19 May 2021 18:42:45 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 19 14:42:45 2021
Received: from localhost ([127.0.0.1]:60723 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ljR9Y-0003hQ-QL
	for submit <at> debbugs.gnu.org; Wed, 19 May 2021 14:42:45 -0400
Received: from mailrelay.tugraz.at ([129.27.2.202]:53170)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <leo.prikler@HIDDEN>) id 1ljR9W-0003hG-Gc
 for 48331 <at> debbugs.gnu.org; Wed, 19 May 2021 14:42:43 -0400
Received: from nijino.local (91-114-247-246.adsl.highway.telekom.at
 [91.114.247.246])
 by mailrelay.tugraz.at (Postfix) with ESMTPSA id 4FlhZ62g9Zz3wZl;
 Wed, 19 May 2021 20:42:38 +0200 (CEST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=tugraz.at;
 s=mailrelay; t=1621449758;
 bh=bEMQMYFabjGzoJ49Mj17o9YZfcuB+v36ChKuhf0dzh8=;
 h=Subject:From:To:Cc:Date:In-Reply-To:References;
 b=mC2nH8JO5/lFLrGPTPLEo3CgCKSjFqrfLZQLHcsA1//zWLvsOrnhLZJFk0i7xLX4B
 JsLkim2NWaZhuzlQNvLqVgFGmW4m+ZOUmD8JKZD5eUkDSroZUXGR1WtUUzPO2Hbu/Z
 bYqFZHdPKYZjrXgUDBeXPO/9n8FS6t0K60yUGHds=
Message-ID: <88a438a74fabe0f4d4bfd8a649c38e960ef82ed2.camel@HIDDEN>
Subject: Re: Emacs' describe-package doesn't work for packages managed by guix
From: Leo Prikler <leo.prikler@HIDDEN>
To: Andrew Tropin <andrew@HIDDEN>
Date: Wed, 19 May 2021 20:42:37 +0200
In-Reply-To: <CABrWRW2OpFaJU-Wz19-smz3OkMx79+rX2WT-N_ZuHkD_Mu6ghQ@HIDDEN>
References: <87im3r81so.fsf@HIDDEN>
 <78cfb495305fb1137da26e37a7ae5dd9467043bf.camel@HIDDEN>
 <CABrWRW3bRnP+vMu6j73o=p2GHbOsLQ-2MejDV5bCNFuqLDD9Sw@HIDDEN>
 <8164abe40ec6e865bf8385e010702cfe158dabcc.camel@HIDDEN>
 <CABrWRW1WfF0J=Pe1E-R2fyx7f6+qLPMs9nj5C2_ZS-G2SZ5bGQ@HIDDEN>
 <6cba9730ace19ecebc397023b243cdb02486cc0c.camel@HIDDEN>
 <CABrWRW1ZYToRkrwVA5t0J3oz9X-tjF3mEyD_GfusDneV1p_9EQ@HIDDEN>
 <437d90a3cc91400fdf0828fea2c989c277a73a7c.camel@HIDDEN>
 <CABrWRW2OpFaJU-Wz19-smz3OkMx79+rX2WT-N_ZuHkD_Mu6ghQ@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
User-Agent: Evolution 3.34.2 
MIME-Version: 1.0
Content-Transfer-Encoding: 7bit
X-TUG-Backscatter-control: bt4lQm5Tva3SBgCuw0EnZw
X-Spam-Scanner: SpamAssassin 3.003001 
X-Spam-Score-relay: -1.9
X-Scanned-By: MIMEDefang 2.74 on 129.27.10.117
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 48331
Cc: Arun Isaac <arunisaac@HIDDEN>, 48331 <at> debbugs.gnu.org,
 Maxim Cournoyer <maxim.cournoyer@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

That looks like it'd mess with people's installed ELPA packages.  In
general, hacks based on package-directory-list don't feel very stable. 
Consider writing a function similar in nature to `package-load-all-
descriptors' instead.

Also, this seems to rely on us not deleting the -pkg.el, but probably
won't work for packages, that don't ship it, e.g. emacs-howm.

[Adding Arun Isaac to CC.  Their commit d8796851 is the first one to
drop -pkg.el, but without explanation.]

Am Mittwoch, den 19.05.2021, 20:58 +0300 schrieb Andrew Tropin:
> From: Andrew Tropin <andrew@HIDDEN>
> Date: Wed, 19 May 2021 20:44:22 +0300
> Subject: [PATCH] guix: build: emacs-build-system: Make package.el
> aware of
>  guix packages
> 
> After updating the package-directory-list variable, functions like
> list-packages,
> describe-package become aware of packages installed by guix.
> 
> ---
> This code is getting work done, but I'm not a very experienced elisp
> developer, so
> please review it thoroughly.
> 
>  gnu/packages/aux-files/emacs/guix-emacs.el | 10 ++++++++++
>  guix/build/emacs-build-system.scm          |  2 +-
>  2 files changed, 11 insertions(+), 1 deletion(-)
> 
> diff --git a/gnu/packages/aux-files/emacs/guix-emacs.el
> b/gnu/packages/aux-files/emacs/guix-emacs.el
> index ca9146c535..4aa4220cda 100644
> --- a/gnu/packages/aux-files/emacs/guix-emacs.el
> +++ b/gnu/packages/aux-files/emacs/guix-emacs.el
> @@ -58,6 +58,16 @@ The files in the list do not have extensions (.el,
> .elc)."
>              (load f 'noerror))
>            autoloads)))
> 
> +
> +(require 'package)
> +
> +;; Set `package-directory-list' to the value without elpa/ suffix
> +;; to match the structure of site-lisp directory of guix's emacs
> +;; build system.
> +;;;###autoload
> +(setq package-directory-list
> +      (list (string-remove-suffix "/elpa" (car package-directory-
> list))))
> +
>  (provide 'guix-emacs)
> 
>  ;;; guix-emacs.el ends here
> diff --git a/guix/build/emacs-build-system.scm
> b/guix/build/emacs-build-system.scm
> index e41e9a6595..7565b9a422 100644
> --- a/guix/build/emacs-build-system.scm
> +++ b/guix/build/emacs-build-system.scm
> @@ -53,7 +53,7 @@
> 
>  ;; These are the default inclusion/exclusion regexps for the install
> phase.
>  (define %default-include '("^[^/]*\\.el$" "^[^/]*\\.info$"
> "^doc/.*\\.info$"))
> -(define %default-exclude '("^\\.dir-locals\\.el$" "-pkg\\.el$"
> +(define %default-exclude '("^\\.dir-locals\\.el$"
>                             "^[^/]*tests?\\.el$"))
> 
>  (define gnu:unpack (assoc-ref gnu:%standard-phases 'unpack))





Information forwarded to bug-guix@HIDDEN:
bug#48331; Package guix. Full text available.

Message received at 48331 <at> debbugs.gnu.org:


Received: (at 48331) by debbugs.gnu.org; 19 May 2021 17:59:02 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 19 13:59:02 2021
Received: from localhost ([127.0.0.1]:60678 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ljQTG-0002bs-Cg
	for submit <at> debbugs.gnu.org; Wed, 19 May 2021 13:59:02 -0400
Received: from mail-qk1-f171.google.com ([209.85.222.171]:34604)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <andrew@HIDDEN>) id 1ljQT9-0002bI-5W
 for 48331 <at> debbugs.gnu.org; Wed, 19 May 2021 13:59:00 -0400
Received: by mail-qk1-f171.google.com with SMTP id v8so13632846qkv.1
 for <48331 <at> debbugs.gnu.org>; Wed, 19 May 2021 10:58:55 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=trop-in.20150623.gappssmtp.com; s=20150623;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=n7K9VOuuX65Swv9GtX88y8FdF9NX61aDrYFsnKITxjc=;
 b=drwmd1AXLd1yFreVe6unc7nFZ6z7gZn4ADrn3wi45QGF+LldZn0VE9MwPTJ6TS7XiV
 H3lpi61ZFtfzM9KIL7Z2Y/cdob8w3oM7hF3k13I2gloz90D/G5s1krjDe7M1OHmIUEYI
 RlEOIg465RlRf4kJjXeoitcEcv1sbv/vJkqbC98+r+VCS/M23Sh5zNuUrLs+4NoEB0BS
 gcm/4ImPvjr5blIk7mZOcjZqL3ikjZFnAA4/4VETPMYSezdIarCQ7G04mVxRsxoFSSGO
 RWHbkzFm8QIlLBN4Fsi2la2GGUdi7E+4rHhh3RrBsawOWsrUZlDV4Ron4fbOFyikfd11
 Fz0Q==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=n7K9VOuuX65Swv9GtX88y8FdF9NX61aDrYFsnKITxjc=;
 b=LT3YfZTb/IqSsVdT/waBekChUmLYp8Rrry5j97C8Eh6yY9PeetcfhL0d98HUm/VSQ8
 J69lhFKf63jVrBLlRxOhy7ILONSupIVtMkRCbJiPy/i2swNu5RgWrgeU3TNUrsdtCS+x
 dXVJJPUCHqyyULbit+iCn3yz6z+IF2Dghath7Tm2zDlIx2X5WxVzZHDxnlv9/oL3vmfv
 tF046MLXDsfCfdBsgTbSAoChFLDs6/VEdpE1qMbjW4jrZ+RLb4BfwRyT1g39dJwUheNO
 5y+tJEAAqmtDmB8PRdWpIUX9TzYA9T45wODqRsBt8S56gxz6qq9oy9Lb+AcIuuHCzSeI
 lhkQ==
X-Gm-Message-State: AOAM530WQDUekRO18Wp866wj1KfKz3LD+UrbTYYhE8xcSwNyR6ePE9RJ
 txI/3/0BGp6MPb5EZxqt0chfRoW+ZINAr6rpAbLuCw==
X-Google-Smtp-Source: ABdhPJzBeNZlLhI+DZH6UYVPkcxJZelHb4kB2qqq5j6r8cZGPWJs1cLStCGYfFo+ebSG/I1FJoKv/MA10H96w0G+NGQ=
X-Received: by 2002:a37:b643:: with SMTP id g64mr686079qkf.6.1621447129547;
 Wed, 19 May 2021 10:58:49 -0700 (PDT)
MIME-Version: 1.0
References: <87im3r81so.fsf@HIDDEN>
 <78cfb495305fb1137da26e37a7ae5dd9467043bf.camel@HIDDEN>
 <CABrWRW3bRnP+vMu6j73o=p2GHbOsLQ-2MejDV5bCNFuqLDD9Sw@HIDDEN>
 <8164abe40ec6e865bf8385e010702cfe158dabcc.camel@HIDDEN>
 <CABrWRW1WfF0J=Pe1E-R2fyx7f6+qLPMs9nj5C2_ZS-G2SZ5bGQ@HIDDEN>
 <6cba9730ace19ecebc397023b243cdb02486cc0c.camel@HIDDEN>
 <CABrWRW1ZYToRkrwVA5t0J3oz9X-tjF3mEyD_GfusDneV1p_9EQ@HIDDEN>
 <437d90a3cc91400fdf0828fea2c989c277a73a7c.camel@HIDDEN>
In-Reply-To: <437d90a3cc91400fdf0828fea2c989c277a73a7c.camel@HIDDEN>
From: Andrew Tropin <andrew@HIDDEN>
Date: Wed, 19 May 2021 20:58:38 +0300
Message-ID: <CABrWRW2OpFaJU-Wz19-smz3OkMx79+rX2WT-N_ZuHkD_Mu6ghQ@HIDDEN>
Subject: Re: Emacs' describe-package doesn't work for packages managed by guix
To: Leo Prikler <leo.prikler@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 48331
Cc: 48331 <at> debbugs.gnu.org, Maxim Cournoyer <maxim.cournoyer@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

From: Andrew Tropin <andrew@HIDDEN>
Date: Wed, 19 May 2021 20:44:22 +0300
Subject: [PATCH] guix: build: emacs-build-system: Make package.el aware of
 guix packages

After updating the package-directory-list variable, functions like
list-packages,
describe-package become aware of packages installed by guix.

---
This code is getting work done, but I'm not a very experienced elisp
developer, so
please review it thoroughly.

 gnu/packages/aux-files/emacs/guix-emacs.el | 10 ++++++++++
 guix/build/emacs-build-system.scm          |  2 +-
 2 files changed, 11 insertions(+), 1 deletion(-)

diff --git a/gnu/packages/aux-files/emacs/guix-emacs.el
b/gnu/packages/aux-files/emacs/guix-emacs.el
index ca9146c535..4aa4220cda 100644
--- a/gnu/packages/aux-files/emacs/guix-emacs.el
+++ b/gnu/packages/aux-files/emacs/guix-emacs.el
@@ -58,6 +58,16 @@ The files in the list do not have extensions (.el, .elc)."
             (load f 'noerror))
           autoloads)))

+
+(require 'package)
+
+;; Set `package-directory-list' to the value without elpa/ suffix
+;; to match the structure of site-lisp directory of guix's emacs
+;; build system.
+;;;###autoload
+(setq package-directory-list
+      (list (string-remove-suffix "/elpa" (car package-directory-list))))
+
 (provide 'guix-emacs)

 ;;; guix-emacs.el ends here
diff --git a/guix/build/emacs-build-system.scm
b/guix/build/emacs-build-system.scm
index e41e9a6595..7565b9a422 100644
--- a/guix/build/emacs-build-system.scm
+++ b/guix/build/emacs-build-system.scm
@@ -53,7 +53,7 @@

 ;; These are the default inclusion/exclusion regexps for the install phase.
 (define %default-include '("^[^/]*\\.el$" "^[^/]*\\.info$" "^doc/.*\\.info$"))
-(define %default-exclude '("^\\.dir-locals\\.el$" "-pkg\\.el$"
+(define %default-exclude '("^\\.dir-locals\\.el$"
                            "^[^/]*tests?\\.el$"))

 (define gnu:unpack (assoc-ref gnu:%standard-phases 'unpack))
-- 
2.31.1




Information forwarded to bug-guix@HIDDEN:
bug#48331; Package guix. Full text available.

Message received at 48331 <at> debbugs.gnu.org:


Received: (at 48331) by debbugs.gnu.org; 19 May 2021 15:08:38 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 19 11:08:38 2021
Received: from localhost ([127.0.0.1]:60429 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ljNoM-0006H9-8w
	for submit <at> debbugs.gnu.org; Wed, 19 May 2021 11:08:38 -0400
Received: from mailrelay.tugraz.at ([129.27.2.202]:20464)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <leo.prikler@HIDDEN>) id 1ljNoI-0006Gt-UC
 for 48331 <at> debbugs.gnu.org; Wed, 19 May 2021 11:08:36 -0400
Received: from nijino.local (91-114-247-246.adsl.highway.telekom.at
 [91.114.247.246])
 by mailrelay.tugraz.at (Postfix) with ESMTPSA id 4Flbq26gGHz1LB20;
 Wed, 19 May 2021 17:08:30 +0200 (CEST)
DKIM-Filter: OpenDKIM Filter v2.11.0 mailrelay.tugraz.at 4Flbq26gGHz1LB20
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=tugraz.at;
 s=mailrelay; t=1621436911;
 bh=5hcWY9nOVvLr4x2e8l1gqctwSK4t7JzUuIL7RzrsGR8=;
 h=Subject:From:To:Cc:Date:In-Reply-To:References:From;
 b=KItqwd7I4GmhY1mQM8Jk5UuCnoDsYYA44iBYKbXQiTv9T4fJR+RYaAOKeS3XIgMGg
 TaqbkNxERutl860U+yJVnGE2h4kxlbiC5EB6ObdfEgVUU5DtFunmhCFOjgcFV0SyUV
 LmyueYo8cEr2TzjtTw0qU7XZU3Qc2vwRUZ7hZFL4=
Message-ID: <437d90a3cc91400fdf0828fea2c989c277a73a7c.camel@HIDDEN>
Subject: Re: Emacs' describe-package doesn't work for packages managed by guix
From: Leo Prikler <leo.prikler@HIDDEN>
To: Andrew Tropin <andrew@HIDDEN>
Date: Wed, 19 May 2021 17:08:30 +0200
In-Reply-To: <CABrWRW1ZYToRkrwVA5t0J3oz9X-tjF3mEyD_GfusDneV1p_9EQ@HIDDEN>
References: <87im3r81so.fsf@HIDDEN>
 <78cfb495305fb1137da26e37a7ae5dd9467043bf.camel@HIDDEN>
 <CABrWRW3bRnP+vMu6j73o=p2GHbOsLQ-2MejDV5bCNFuqLDD9Sw@HIDDEN>
 <8164abe40ec6e865bf8385e010702cfe158dabcc.camel@HIDDEN>
 <CABrWRW1WfF0J=Pe1E-R2fyx7f6+qLPMs9nj5C2_ZS-G2SZ5bGQ@HIDDEN>
 <6cba9730ace19ecebc397023b243cdb02486cc0c.camel@HIDDEN>
 <CABrWRW1ZYToRkrwVA5t0J3oz9X-tjF3mEyD_GfusDneV1p_9EQ@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
User-Agent: Evolution 3.34.2 
MIME-Version: 1.0
Content-Transfer-Encoding: 7bit
X-TUG-Backscatter-control: bt4lQm5Tva3SBgCuw0EnZw
X-Spam-Scanner: SpamAssassin 3.003001 
X-Spam-Score-relay: -1.9
X-Scanned-By: MIMEDefang 2.74 on 129.27.10.117
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 48331
Cc: 48331 <at> debbugs.gnu.org, Maxim Cournoyer <maxim.cournoyer@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Am Mittwoch, den 19.05.2021, 17:32 +0300 schrieb Andrew Tropin:
> > > Most other package managers seem to respect "infrastructure"
> > > provided by package.el.
> > I don't think that statement is well-supported by the data we have.
> 
> Agree, that was an incorrect statement. I should have said something
> like: there are some popular tools like use-package configuration
> helper, Nix package manager, Spacemacs configuration framework, some
> elisp archives and probably something else, which utilize and follow
> package.el.  Not all of them use package.el itself, but they follow
> conventions and describe-package help command and some other work
> correctly.
Is package.el really so well supported by all these tools?  I might
concede, that some of them don't throw away the package.el blurb like
guix does, but other than that, I think you'd have a hard time stuffing
a random git repo from use-package into package.el.  Am I missing
something?

> > Why should we let ELPA dictate our layout?  I have not even once
> > tried customizing package.el for actual use since I got Guix,
> > because the elpa importer is trivial.
> 
> We don't have to.  Actually, I'm very happy with the new (current)
> layout we have right now.
That's good :)

> I would say I find the following use case very confusing for
> newcomers:
> - Install emacs package via Guix.
> - Use built-in help C-h C-h, find C-h P.
> - Get it to work for built-in packages, but not for packages
> installed by Guix.
> - Get frustrated.
You mean Emacs newcomers?  Tell me something new about the first-time
Emacs experience :P

> I think we could avoid this at least in two ways:
> 1. Use elpa/ subdirectory.
> 2. Keep current structure, set package-directory-list to .../site-
> lisp instead of .../site-lisp/elpa by default.
Neither sounds very pleasant, but does (2) even work?

> > Thus we're not trying to keep in line with any specific package
> > manager, we just need to make things work "with Emacs" in the sense
> > that packages installed via Guix should have working autoloads and
> > one should be able to (require ...) them.
> 
> Yes, but at the same time I don't see reasons why not to implement
> one of two options above.  We can get both: working autoloads and
> working built-in help function (+newcommers won't be so frustrated).
Of course.  The glue code for that would go into guix-emacs.el, just
like our autoload glue.

> Personally, I'm quite happy that packages got their own
> subdirectories and I'm fully satisfied with current state of it, but
> it would be cool if inexperienced users will be able to use at least
> built-in help commands for packages out of the box without additional
> configuration.
> 
> Hope my original point is a little better worded now.
Doing something in Emacs without configuration sounds like an oxymoron,
but I get your point.  At the same time, I think that this kind of
change is a pretty large request (DPD has more than 100 lines not
counting dependencies, it's not small and neat like guix-emacs.el).

If you find a clever trick to make your troubles go away, do submit a
patch, but don't let it rely on user setup (in particular, don't rely
on "haha, the user always carries about the elpa subdirectory").

Regards,
Leo





Information forwarded to bug-guix@HIDDEN:
bug#48331; Package guix. Full text available.

Message received at 48331 <at> debbugs.gnu.org:


Received: (at 48331) by debbugs.gnu.org; 19 May 2021 14:41:27 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 19 10:41:27 2021
Received: from localhost ([127.0.0.1]:60410 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ljNO3-0005ZE-Hb
	for submit <at> debbugs.gnu.org; Wed, 19 May 2021 10:41:27 -0400
Received: from mail-qv1-f41.google.com ([209.85.219.41]:45629)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <andrew@HIDDEN>) id 1ljNO1-0005Yy-RD
 for 48331 <at> debbugs.gnu.org; Wed, 19 May 2021 10:41:26 -0400
Received: by mail-qv1-f41.google.com with SMTP id h7so6229654qvs.12
 for <48331 <at> debbugs.gnu.org>; Wed, 19 May 2021 07:41:25 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=trop-in.20150623.gappssmtp.com; s=20150623;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=+U7snOLOdi85jleV0W0DrVt9KDTtrhndae9BkVP0PtA=;
 b=yOTJEApL50ihRXQwOX768m61QFXXVgkxo7QdDgiIDQGssU+02grRJcM3M8t179K8qN
 V6XetKuJanZ6XsQ5aH+99by1fA/oe7zoft2eYdSQU2qUYI5O0kV5Q47ffcvR2bO2zwdk
 Uqx6TQOm+hrT9x0y2KULlpMo2wa0snMnEaNI24x1oDt2NW5zYFanZUTDd/JXt+EaOQiF
 r9EyCnTnpwWgIE9DL9F6osQNVsFOC6TJmWE8xCN84pFdN6g2LeveIokl/aEXERVE2tnj
 XA6wp16/lhc6HMcmWbQQ/8lv71P238PEbVQeG3k6r10LItSE3D2e+wKfp7FRePWelJVm
 LvTA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=+U7snOLOdi85jleV0W0DrVt9KDTtrhndae9BkVP0PtA=;
 b=WRKVygzGCIK6jSnzHQXxFmleI3NWAApzyYcoAxddLJHJGfP534BmXQ6c/2fnnvR13p
 nbsesyxFZsarhvSdIIhtAn5TJ2NFGyZOEC7KUk+LICXAdkbEmMb4xPj0luGjIeYti14T
 WRzvHk3D5L4tObzUo3eAu0LutSiWItYeJH7RQAR1k3+SS3+6laH2NxRVb+ChvAGy28yF
 KtJDVF0g5mu0Slfms1ABV+pnu5fGzNTAqwVoniom9QPMjx0juEGt/VnEMT1ygWsF+Wm9
 RK8noVgNNx9CWewLC6mnpEBXJ1s8PDzE7x+zSXnkMpxvI4VczgxmrnBuRqQTf3Ps9DJd
 HDkQ==
X-Gm-Message-State: AOAM530sFs1I9WcwtsXt+yp9VjBjqedNNUekAQmgPOx5cCwv+lReHiWI
 j2pIFdmZDeQSI5TH2hG016CkuH3hqCSOJrsew+8tadkATTNUq38+
X-Google-Smtp-Source: ABdhPJwWXY6yrC7zk6jkZVYbJXLGjXd6pTFLgKcqrrZWjQg8RjVy/SzA0Yq+DQZBLD8Z9oWoOwHWSpOZgf2X6A9PMrI=
X-Received: by 2002:ad4:4d48:: with SMTP id m8mr7148554qvm.12.1621435280290;
 Wed, 19 May 2021 07:41:20 -0700 (PDT)
MIME-Version: 1.0
References: <87im3r81so.fsf@HIDDEN> <87mtt1ug0h.fsf@HIDDEN>
In-Reply-To: <87mtt1ug0h.fsf@HIDDEN>
From: Andrew Tropin <andrew@HIDDEN>
Date: Wed, 19 May 2021 17:41:09 +0300
Message-ID: <CABrWRW22yBqjQMKbGZbNUvjHh+bkRuduHNzXLvgCK0XErQuZnw@HIDDEN>
Subject: Re: bug#48331: Emacs' describe-package doesn't work for packages
 managed by guix
To: =?UTF-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 48331
Cc: 48331 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

> > M-x list-packages ;; Doesn't list treemacs

> Let me recommend Emacs-Guix (aka. 'guix.el') as a superior alternative.
> :-)

Sure) Aware of it, cool tool.

> I think it's fine that 'package.el' is unaware of Guix-managed software
> and vice-versa.

Yep, perfectly fine, but why not to make it aware, if it is relatively
easy to achieve?)




Information forwarded to bug-guix@HIDDEN:
bug#48331; Package guix. Full text available.

Message received at 48331 <at> debbugs.gnu.org:


Received: (at 48331) by debbugs.gnu.org; 19 May 2021 14:32:36 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 19 10:32:36 2021
Received: from localhost ([127.0.0.1]:60397 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ljNFT-0005Kf-Pd
	for submit <at> debbugs.gnu.org; Wed, 19 May 2021 10:32:36 -0400
Received: from mail-qk1-f177.google.com ([209.85.222.177]:45615)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <andrew@HIDDEN>) id 1ljNFK-0005KH-K8
 for 48331 <at> debbugs.gnu.org; Wed, 19 May 2021 10:32:34 -0400
Received: by mail-qk1-f177.google.com with SMTP id i5so5658272qkf.12
 for <48331 <at> debbugs.gnu.org>; Wed, 19 May 2021 07:32:26 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=trop-in.20150623.gappssmtp.com; s=20150623;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=Yg8aDPRq+PeUjqtkPOcs6YiX34Wd/Sc8+S9OKLMrrGk=;
 b=VavXJZF9cVbuqrGUpIevdOgIHlDuFcebJ6amwb5zDP9MbrL//i/K4sjf1NIwVjzfjc
 OOlwioEkSdK4AM2/QKg4Q5s7rhijuyPWFjl51ELvtdUM0frgsdE+lmLtOze1UuteOLC/
 jb8FpJHFIZXnbDu8sNSDOdA8RBFoQpqe3d+rD4kqi4joPVHTUYDpPpiQ3PxDJWFuTmR6
 LUl+OKi2MfpqWe+wv7/nAMrtWtlk29qJo4C2t9p0ecq2ek28/4xHoOuqamplyYtIetIU
 VhCAWPatrO52Fb6tEsNqOXorcpWq/juDAXXW7OVi4/+Uki9UuOPxV4cfu85MWqG/f2nY
 Yh8Q==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=Yg8aDPRq+PeUjqtkPOcs6YiX34Wd/Sc8+S9OKLMrrGk=;
 b=YvMtGa0i8Cz3MR4rVZEzOcVycys/+rEBbUIJqgKasQ6ba4WFU95uBz1oMZkGyu324v
 na+Cduie9bynwxpEPPkT6bzDUEUJau2xeSPlX9LrKDJ5dbdtmVMLMfsU1Us89Nw+qt3R
 dKsKagGBGNH6G5hcBLgAPXvL3dpdSfjWE6y0wF1lUvf14t+IJHoMsUSP2+fb5n1eHcsc
 GwqyMAqv5ZZL4tEyi2vmU2nxFVBb4ZqTH38NAfpdegmUMc4MYrUnCYp8nf4Z0nxzn6pa
 h5o1Jn+rxD0Qa4AygaUBlsWQJXi/NTBEkjmCe4o3fpO1kjpNgLoA9rxFrNkeqswZE0Ub
 C9AA==
X-Gm-Message-State: AOAM531B9WyRwpow2jm+P5hxoCAM/i+W1uXvJi5e8qe0mQ8VVFXYhzLv
 hZtwN7ZHlJPALnnk4CImufzGvfZP3PNVKS/RlbLb1g==
X-Google-Smtp-Source: ABdhPJyjBuPUOq1XCmvCjlL2VgDSyr3yjTVQkWxB2xGbTscmasqTOpP5OipwmL2Z9C0J5P4PNxnvc5n0Iz77LH8soL4=
X-Received: by 2002:a05:620a:448c:: with SMTP id
 x12mr12463680qkp.52.1621434741018; 
 Wed, 19 May 2021 07:32:21 -0700 (PDT)
MIME-Version: 1.0
References: <87im3r81so.fsf@HIDDEN>
 <78cfb495305fb1137da26e37a7ae5dd9467043bf.camel@HIDDEN>
 <CABrWRW3bRnP+vMu6j73o=p2GHbOsLQ-2MejDV5bCNFuqLDD9Sw@HIDDEN>
 <8164abe40ec6e865bf8385e010702cfe158dabcc.camel@HIDDEN>
 <CABrWRW1WfF0J=Pe1E-R2fyx7f6+qLPMs9nj5C2_ZS-G2SZ5bGQ@HIDDEN>
 <6cba9730ace19ecebc397023b243cdb02486cc0c.camel@HIDDEN>
In-Reply-To: <6cba9730ace19ecebc397023b243cdb02486cc0c.camel@HIDDEN>
From: Andrew Tropin <andrew@HIDDEN>
Date: Wed, 19 May 2021 17:32:10 +0300
Message-ID: <CABrWRW1ZYToRkrwVA5t0J3oz9X-tjF3mEyD_GfusDneV1p_9EQ@HIDDEN>
Subject: Re: Emacs' describe-package doesn't work for packages managed by guix
To: Leo Prikler <leo.prikler@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 48331
Cc: 48331 <at> debbugs.gnu.org, Maxim Cournoyer <maxim.cournoyer@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

> > Most other package managers seem to respect "infrastructure" provided
> > by package.el.
> I don't think that statement is well-supported by the data we have.

Agree, that was an incorrect statement. I should have said something like:
there are some popular tools like use-package configuration helper, Nix
package manager, Spacemacs configuration framework, some elisp archives
and probably something else, which utilize and follow package.el.  Not
all of them use package.el itself, but they follow conventions and
describe-package help command and some other work correctly.

> Why should we let ELPA dictate our layout?  I have not even once tried
> customizing package.el for actual use since I got Guix, because the
> elpa importer is trivial.

We don't have to.  Actually, I'm very happy with the new (current) layout we
have right now.

I would say I find the following use case very confusing for newcomers:
- Install emacs package via Guix.
- Use built-in help C-h C-h, find C-h P.
- Get it to work for built-in packages, but not for packages installed by Guix.
- Get frustrated.

I think we could avoid this at least in two ways:
1. Use elpa/ subdirectory.
2. Keep current structure, set package-directory-list to .../site-lisp
instead of .../site-lisp/elpa by default.

> Thus we're not trying to keep in line with any specific package
> manager, we just need to make things work "with Emacs" in the sense
> that packages installed via Guix should have working autoloads and one
> should be able to (require ...) them.

Yes, but at the same time I don't see reasons why not to implement one
of two options above.  We can get both: working autoloads and working
built-in help function (+newcommers won't be so frustrated).

Personally, I'm quite happy that packages got their own subdirectories
and I'm fully satisfied with current state of it, but it would be cool
if inexperienced users will be able to use at least built-in help
commands for packages out of the box without additional configuration.

Hope my original point is a little better worded now.

-- 
Best regards,
Andrew Tropin




Information forwarded to bug-guix@HIDDEN:
bug#48331; Package guix. Full text available.

Message received at 48331 <at> debbugs.gnu.org:


Received: (at 48331) by debbugs.gnu.org; 11 May 2021 21:17:43 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue May 11 17:17:43 2021
Received: from localhost ([127.0.0.1]:37655 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lgZl8-0006U4-T6
	for submit <at> debbugs.gnu.org; Tue, 11 May 2021 17:17:43 -0400
Received: from eggs.gnu.org ([209.51.188.92]:38028)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1lgZl7-0006Pn-JW
 for 48331 <at> debbugs.gnu.org; Tue, 11 May 2021 17:17:42 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:38386)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1lgZl2-0001rq-Ar; Tue, 11 May 2021 17:17:36 -0400
Received: from [2a01:e0a:1d:7270:af76:b9b:ca24:c465] (port=33438 helo=ribbon)
 by fencepost.gnu.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1lgZl1-0002kn-Q4; Tue, 11 May 2021 17:17:36 -0400
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: Andrew Tropin <andrew@HIDDEN>
Subject: Re: bug#48331: Emacs' describe-package doesn't work for packages
 managed by guix
References: <87im3r81so.fsf@HIDDEN>
X-URL: http://www.fdn.fr/~lcourtes/
X-Revolutionary-Date: 22 =?utf-8?Q?Flor=C3=A9al?= an 229 de la =?utf-8?Q?R?=
 =?utf-8?Q?=C3=A9volution?=
X-PGP-Key-ID: 0x090B11993D9AEBB5
X-PGP-Key: http://www.fdn.fr/~lcourtes/ludovic.asc
X-PGP-Fingerprint: 3CE4 6455 8A84 FDC6 9DB4  0CFB 090B 1199 3D9A EBB5
X-OS: x86_64-pc-linux-gnu
Date: Tue, 11 May 2021 23:17:34 +0200
In-Reply-To: <87im3r81so.fsf@HIDDEN> (Andrew Tropin's message of "Mon, 10 May
 2021 10:51:03 +0300")
Message-ID: <87mtt1ug0h.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 48331
Cc: 48331 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Hi,

Andrew Tropin <andrew@HIDDEN> skribis:

> M-x list-packages ;; Doesn't list treemacs

Let me recommend Emacs-Guix (aka. =E2=80=98guix.el=E2=80=99) as a superior =
alternative.
:-)

I think it=E2=80=99s fine that =E2=80=98package.el=E2=80=99 is unaware of G=
uix-managed software
and vice-versa.

Ludo=E2=80=99.




Information forwarded to bug-guix@HIDDEN:
bug#48331; Package guix. Full text available.

Message received at 48331 <at> debbugs.gnu.org:


Received: (at 48331) by debbugs.gnu.org; 11 May 2021 19:57:11 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue May 11 15:57:11 2021
Received: from localhost ([127.0.0.1]:37526 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lgYVC-0002KT-P1
	for submit <at> debbugs.gnu.org; Tue, 11 May 2021 15:57:11 -0400
Received: from mailrelay.tugraz.at ([129.27.2.202]:57574)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <leo.prikler@HIDDEN>) id 1lgYVA-0002KH-4z
 for 48331 <at> debbugs.gnu.org; Tue, 11 May 2021 15:57:09 -0400
Received: from nijino.local (91-114-247-246.adsl.highway.telekom.at
 [91.114.247.246])
 by mailrelay.tugraz.at (Postfix) with ESMTPSA id 4Ffpbg48Rqz3x8F;
 Tue, 11 May 2021 21:57:03 +0200 (CEST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=tugraz.at;
 s=mailrelay; t=1620763023;
 bh=yX30V6mXr1kVIeqkqT6Bltcii812sBWLitmzkWteoJE=;
 h=Subject:From:To:Cc:Date:In-Reply-To:References;
 b=NS7it26/lilEvoLEqmoWGbOkAgv5Sp8BbHyHbTaS4VLVnQvm4QnfPDMt3N7YxvKZc
 4eFl3mxEzZzlEY+cH9z0yj/CdsrANUJWvw/1z8sWtamTssvQHRPYBtrVLDb6zx0FtT
 JfVtn9A6E5Xu1C443ZF3b1UVlG1x3bKT7/wyITEY=
Message-ID: <6cba9730ace19ecebc397023b243cdb02486cc0c.camel@HIDDEN>
Subject: Re: Emacs' describe-package doesn't work for packages managed by guix
From: Leo Prikler <leo.prikler@HIDDEN>
To: Andrew Tropin <andrew@HIDDEN>
Date: Tue, 11 May 2021 21:57:02 +0200
In-Reply-To: <CABrWRW1WfF0J=Pe1E-R2fyx7f6+qLPMs9nj5C2_ZS-G2SZ5bGQ@HIDDEN>
References: <87im3r81so.fsf@HIDDEN>
 <78cfb495305fb1137da26e37a7ae5dd9467043bf.camel@HIDDEN>
 <CABrWRW3bRnP+vMu6j73o=p2GHbOsLQ-2MejDV5bCNFuqLDD9Sw@HIDDEN>
 <8164abe40ec6e865bf8385e010702cfe158dabcc.camel@HIDDEN>
 <CABrWRW1WfF0J=Pe1E-R2fyx7f6+qLPMs9nj5C2_ZS-G2SZ5bGQ@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
User-Agent: Evolution 3.34.2 
MIME-Version: 1.0
Content-Transfer-Encoding: 8bit
X-TUG-Backscatter-control: bt4lQm5Tva3SBgCuw0EnZw
X-Spam-Scanner: SpamAssassin 3.003001 
X-Spam-Score-relay: -1.9
X-Scanned-By: MIMEDefang 2.74 on 129.27.10.117
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 48331
Cc: 48331 <at> debbugs.gnu.org, Maxim Cournoyer <maxim.cournoyer@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Am Dienstag, den 11.05.2021, 21:55 +0300 schrieb Andrew Tropin:
> > the "-pkg\\.el$" exclude might have existed for a reason
> > (I don't know which, put perhaps byte compilation).
> 
> Perhaps it should be ignored during byte compilation, but still
> installing it seems to be a good idea.  Ok, let's wait for Maxim
> answer.
I think we agree on that.

> > I know people take package.el for granted nowadays, but alternative
> > package managers for Emacs have their uses.  This is not just a
> > Guix thing :)
> 
> Why not take it for granted?)  It's built-in since 24(?), elpa/melpa
> archives respect it format and provide package descriptions in
> -pkg.el format, AFAIK.  
el-get[1] is still active.
straight.el[2] is another package manager for Emacs, its README
comparing 5+1 approaches for package mangers, including el-get and
package.el.  Those are very much wild lands, I say.

Not to speak for all the distro-specific ways of handling things. 
Gentoo had (and probably still has) an overlay, that magically creates
Gentoo packages from elpa – in which of course they drop the -pkg.el. 
Debian has a mix of elpa packages and non-elpa ones, some of which
naturally don't have the -pkg.el either.  (Also their packages use
site-lisp/elpa-src instead of site-lisp/elpa).  Arch also seems to
install at least some Elisp packages "directly" in site-lisp/$PACKAGE.

> Most other package managers seem to respect "infrastructure" provided
> by package.el. 
I don't think that statement is well-supported by the data we have. 

> Don't see too many reasons not to follow this format.
> 
> I mean it's easily fixable with current directory structure just by
> stripping "/elpa" suffix from package-directory-list, but why we
> would do that emacs "customization" instead of just placing packages
> under /elpa subdirectory and make everything work out of the box?
Why should we let ELPA dictate our layout?  I have not even once tried
customizing package.el for actual use since I got Guix, because the
elpa importer is trivial.

> > I don't think we want to fake elpa that hard.  Two iterations ago
> > it was .guix.d and people didn't really like it.
> 
> Do you mean the package installation path was site-lisp/.guix.d/NAME-
> VERSION?
Yep, that was a kinda ELPA-y convention while also remaining more true
to what we're doing.

> > My subdirs.el patch is also stretching it.
> 
> Not sure what you mean by this, sorry, I'm not native speaker and
> automated translation doesn't make sense to me.  Rephrase please.
The patch, which I've made, that adds subdirs.el is not
uncontroversial.

> I do not insist on any particular directory structure, just curious
> why not to stick to the widely adopted format.  Once again, thank you
> for placing packages into subdirectories, now the site-lisp structure
> seems more organized and less polluted + problem with describe-
> package (C-h P) and list-packages are easily fixable.  Appreciate
> your work!)
I hope I've shed some light as to how "wide" this adoption actually is
– Emacs users are a contentious people.  Just because something is "the
default" and enjoys being shipped with Emacs itself doesn't mean that
everyone is happy with it.

Thus we're not trying to keep in line with any specific package
manager, we just need to make things work "with Emacs" in the sense
that packages installed via Guix should have working autoloads and one
should be able to (require ...) them.

Regards,
Leo

[1] https://github.com/dimitri/el-get
[2] https://github.com/raxod502/straight.el





Information forwarded to bug-guix@HIDDEN:
bug#48331; Package guix. Full text available.

Message received at 48331 <at> debbugs.gnu.org:


Received: (at 48331) by debbugs.gnu.org; 11 May 2021 18:56:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue May 11 14:56:03 2021
Received: from localhost ([127.0.0.1]:37385 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lgXY2-0000mO-Qe
	for submit <at> debbugs.gnu.org; Tue, 11 May 2021 14:56:03 -0400
Received: from mail-qk1-f176.google.com ([209.85.222.176]:38441)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <andrew@HIDDEN>) id 1lgXY0-0000lg-Ff
 for 48331 <at> debbugs.gnu.org; Tue, 11 May 2021 14:56:01 -0400
Received: by mail-qk1-f176.google.com with SMTP id q10so15667936qkc.5
 for <48331 <at> debbugs.gnu.org>; Tue, 11 May 2021 11:56:00 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=trop-in.20150623.gappssmtp.com; s=20150623;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=ldm7Vmt8hIhpLT6X/1nbd+3Ifld0FDlOIveerZjZ5rk=;
 b=gdbGydlNIhnZs9nrKzTLkDYhaSiYbeIGXX2UwC72JK7RtTuRoXTP2O5Y8ckTsDBLyV
 qw0Nb3sEEKPGRbeeZnM7dnuxVdx5XIS9FnZy1WPZS9z72bGCII+EYlBQLNQAfBtHAIBO
 HIVKHRtFp6FMdXRYXTBgIRj2lGjq7OwVrnejnzR0bN63dh2XEaGmZ7AgpdJHxl2q84mM
 ci6oMo9R6QexkAYjIPURqgN+5W6IZ2eWx09mLDwiFLg/ctRS8/vpE3MCuK/RskqeGu52
 VOcU0AJiwufCXC6pOqeHPXZV93VX/b6eFHe9gQ2sLuxKlJ82eSehouWKfi+yetLxtJMj
 /zZg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=ldm7Vmt8hIhpLT6X/1nbd+3Ifld0FDlOIveerZjZ5rk=;
 b=BrD0kLNoznBOvPaFJY4NDATCtbF+5rUG7+9dQJlq8zJujbYeeq2S8teehYn76q2HFL
 99X7qe3Cd5D+kQ7AJCBRUyZ2NY9MfTOlzbXfxME31AoLHFgDEG2VJvJLLtAE99n86G7T
 EJLsuVgv7JfqN+aZ+mTgg5oeSlA3COe6cJZJyNiV5BmOihEyeiSbxui6gHYVmHWCg/rE
 Tj450qu/mO9gbLHWQ94B/LB8yZD23u6kiS774L3VOVISSqApyU7AJfC0yMTv0nDbu4pq
 v5TW8Kahkeraxz6gGvWh+lQwUhgb7HsSAQLQyrP0ggcg3M/tg7P8MgFTNikYlDxgYTNO
 h7oQ==
X-Gm-Message-State: AOAM530UEDayaAzlaohpOIgTnsrOuSPcaDSHYIaBOgHXKoVMCNoaeEkJ
 Y5vhxn8YBVbg7NyiRQVNTTlLEClScM0YUeZAOFSJ/Q==
X-Google-Smtp-Source: ABdhPJz94v5yDazmwczmv2AGM+vNMv6Xbqtd8+dqQXhoUysqtBAHF+7U8ebRGvwsW6ybeeD1fVrOhlDkECnqDNXn/R4=
X-Received: by 2002:a05:620a:126d:: with SMTP id
 b13mr8415330qkl.436.1620759354762; 
 Tue, 11 May 2021 11:55:54 -0700 (PDT)
MIME-Version: 1.0
References: <87im3r81so.fsf@HIDDEN>
 <78cfb495305fb1137da26e37a7ae5dd9467043bf.camel@HIDDEN>
 <CABrWRW3bRnP+vMu6j73o=p2GHbOsLQ-2MejDV5bCNFuqLDD9Sw@HIDDEN>
 <8164abe40ec6e865bf8385e010702cfe158dabcc.camel@HIDDEN>
In-Reply-To: <8164abe40ec6e865bf8385e010702cfe158dabcc.camel@HIDDEN>
From: Andrew Tropin <andrew@HIDDEN>
Date: Tue, 11 May 2021 21:55:43 +0300
Message-ID: <CABrWRW1WfF0J=Pe1E-R2fyx7f6+qLPMs9nj5C2_ZS-G2SZ5bGQ@HIDDEN>
Subject: Re: Emacs' describe-package doesn't work for packages managed by guix
To: Leo Prikler <leo.prikler@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 48331
Cc: 48331 <at> debbugs.gnu.org, Maxim Cournoyer <maxim.cournoyer@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

> the "-pkg\\.el$" exclude might have existed for a reason
> (I don't know which, put perhaps byte compilation).

Perhaps it should be ignored during byte compilation, but still
installing it seems to be a good idea.  Ok, let's wait for Maxim answer.

> I know people take package.el for granted nowadays, but alternative
> package managers for Emacs have their uses.  This is not just a Guix
> thing :)

Why not take it for granted?)  It's built-in since 24(?), elpa/melpa
archives respect it format and provide package descriptions in -pkg.el
format, AFAIK.  Most other package managers seem to respect
"infrastructure" provided by package.el. For example you can view a list
of packages with `list-packages` even for packages installed with other
PMs (Nix for example), BTW they keep "package.el" directory structure.
https://0x0.st/-BxL.txt

Don't see too many reasons not to follow this format.

I mean it's easily fixable with current directory structure just by
stripping "/elpa" suffix from package-directory-list, but why we would
do that emacs "customization" instead of just placing packages under /elpa
subdirectory and make everything work out of the box?

> I don't think we want to fake elpa that hard.  Two iterations ago it
> was .guix.d and people didn't really like it.

Do you mean the package installation path was site-lisp/.guix.d/NAME-VERSION?

> My subdirs.el patch is also stretching it.

Not sure what you mean by this, sorry, I'm not native speaker and
automated translation doesn't make sense to me.  Rephrase please.

I do not insist on any particular directory structure, just curious why
not to stick to the widely adopted format.  Once again, thank you for placing
packages into subdirectories, now the site-lisp structure seems more
organized and less polluted + problem with describe-package (C-h P) and
list-packages are easily fixable.  Appreciate your work!)

-- 
Best regards,
Andrew Tropin




Information forwarded to bug-guix@HIDDEN:
bug#48331; Package guix. Full text available.

Message received at 48331 <at> debbugs.gnu.org:


Received: (at 48331) by debbugs.gnu.org; 11 May 2021 16:33:45 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue May 11 12:33:45 2021
Received: from localhost ([127.0.0.1]:37223 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lgVKL-0003cl-58
	for submit <at> debbugs.gnu.org; Tue, 11 May 2021 12:33:45 -0400
Received: from mailrelay.tugraz.at ([129.27.2.202]:54426)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <leo.prikler@HIDDEN>) id 1lgVKH-0003cY-C9
 for 48331 <at> debbugs.gnu.org; Tue, 11 May 2021 12:33:43 -0400
Received: from nijino.local (91-114-247-246.adsl.highway.telekom.at
 [91.114.247.246])
 by mailrelay.tugraz.at (Postfix) with ESMTPSA id 4Ffk4x5tVDz3xqb;
 Tue, 11 May 2021 18:33:37 +0200 (CEST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=tugraz.at;
 s=mailrelay; t=1620750818;
 bh=0a8MTnRt9WsyJBbj9iVeUNqDpA5DVkuWjg4xWqNzLCU=;
 h=Subject:From:To:Cc:Date:In-Reply-To:References;
 b=E0YZuOfK2n9deQDRUgc1/Fl0NZFS/a1HGNaW7c84xF0S2/juOs7SCDqzZDQE0pnjd
 FMFpwvu2Ebequo0qZCLjDxjMe4P8ext9XuRkRrURADGfpNF64coPKSl1NZGG4frmEL
 t4na9WThKBlmbMXyrWHvwBMr/JHKnHpYHUrt5AU4=
Message-ID: <8164abe40ec6e865bf8385e010702cfe158dabcc.camel@HIDDEN>
Subject: Re: Emacs' describe-package doesn't work for packages managed by guix
From: Leo Prikler <leo.prikler@HIDDEN>
To: Andrew Tropin <andrew@HIDDEN>
Date: Tue, 11 May 2021 18:33:37 +0200
In-Reply-To: <CABrWRW3bRnP+vMu6j73o=p2GHbOsLQ-2MejDV5bCNFuqLDD9Sw@HIDDEN>
References: <87im3r81so.fsf@HIDDEN>
 <78cfb495305fb1137da26e37a7ae5dd9467043bf.camel@HIDDEN>
 <CABrWRW3bRnP+vMu6j73o=p2GHbOsLQ-2MejDV5bCNFuqLDD9Sw@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
User-Agent: Evolution 3.34.2 
MIME-Version: 1.0
Content-Transfer-Encoding: 7bit
X-TUG-Backscatter-control: bt4lQm5Tva3SBgCuw0EnZw
X-Spam-Scanner: SpamAssassin 3.003001 
X-Spam-Score-relay: -1.9
X-Scanned-By: MIMEDefang 2.74 on 129.27.10.117
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 48331
Cc: 48331 <at> debbugs.gnu.org, Maxim Cournoyer <maxim.cournoyer@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Am Dienstag, den 11.05.2021, 18:57 +0300 schrieb Andrew Tropin:
> Patched emacs-build-system to place packages under elpa/NAME-VERSION
> subdirectory and removed "-pkg\\.el$" from %default-exclude.
I don't know whether that's a good idea.  The elpa/ part I already
dislike, and the "-pkg\\.el$" exclude might have existed for a reason
(I don't know which, put perhaps byte compilation).

> > I have now published emacs-dpd [2], which does exactly that.  To
> > use it
> > for your Guix Emacs packages, execute
> >   (dpd (list "$GUIX_PROFILE/share/emacs/site-lisp" ...))
> > replacing "$GUIX_PROFILE" with the actual profile, after `package-
> > initialize' has run with `dpd-fuzzy-recognize' in `dpd-recognize-
> > hook'.
> > I might write a more detailed README later.
> 
> Most of the packages already have -pkg.el in sources, but yep, pretty
> cool utility, also thought about implementing something like that
> yesterday, but luckily I didn't and now I do not need to do it,
> because
> now I'm aware of already-existing implementations!)
I know people take package.el for granted nowadays, but alternative
package managers for Emacs have their uses.  This is not just a Guix
thing :)

> > Neither packed nor dpd are currently packaged in Guix.  packed can
> > easily be imported from melpa-stable, but for dpd you'd have to
> > write
> > your own guix.scm.  I might do that at some point as well.
> > We already had modifications in emacs-build-system recently, so if
> > you
> > want to argue, that all Emacs packages should have that <package>-
> > pkg.el to work with package.el out of the box, I would ask you to
> > wait,
> > so as to not cause an "Emacs world" rebuild again after only ten
> > days.
> > I also don't know whether Guix has the same information as
> > package.el
> > at build time, but that might change with time as
> > well.  Particularly,
> > there will hopefully be a move towards supplying name and version
> > at
> > build, which would give us the most important information.
> 
> Very cool, I didn't have the latest changes on my local checkout and
> didn't
> see your commits, but now I see, it is exactly what I needed.
> 
> The only side note: it should be site-lisp/elpa/NAME-VERSION (right
> now
> it is site-lisp/NAME-VERSION).  Also, on line 137 elpa-directory
> function can be used.
I don't think we want to fake elpa that hard.  Two iterations ago it
was .guix.d and people didn't really like it.  My subdirs.el patch is
also stretching it.  So I really don't want to add another subdirectory
layer to it.
If elpa can't deal with that, we'll have to code around it in Elisp.

> When you will be updating the path, please remove -pkg.el from
> %default-exclude.
I've CC'd Maxim, perhaps they know more about %default-exclude.

Regards,
Leo





Information forwarded to bug-guix@HIDDEN:
bug#48331; Package guix. Full text available.

Message received at 48331 <at> debbugs.gnu.org:


Received: (at 48331) by debbugs.gnu.org; 11 May 2021 15:57:38 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue May 11 11:57:37 2021
Received: from localhost ([127.0.0.1]:37177 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lgUlN-0002h3-Kz
	for submit <at> debbugs.gnu.org; Tue, 11 May 2021 11:57:37 -0400
Received: from mail-qk1-f179.google.com ([209.85.222.179]:43573)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <andrew@HIDDEN>) id 1lgUlL-0002gm-FP
 for 48331 <at> debbugs.gnu.org; Tue, 11 May 2021 11:57:36 -0400
Received: by mail-qk1-f179.google.com with SMTP id a22so18635630qkl.10
 for <48331 <at> debbugs.gnu.org>; Tue, 11 May 2021 08:57:35 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=trop-in.20150623.gappssmtp.com; s=20150623;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=QbxjEEbfeiMzamdYCZoFeEELJ/GH0lJF8H6HQ+hOaxM=;
 b=ZvLDzILELPGxiM0HakvionoElEMPmmpiufm71mn74sLsePi+2VhxbDRe9cKnZrHdAr
 CdsqChAo6wK0i3uLmAHEKau6G37QD05CP24jg7bFvrZ9m3uNXCnYb44avIyyKvGoTE+d
 KHeAqXBepz6HFj66hpBm9sN3gLZshg7V1e4XyUxJdurlH6EyEnM4PtY4BHtDyx2i14AJ
 4spx+h+z+SeNusMlM6LdglgTp60KJJFyfPi04pO2iI1ZNFSEH0FjVYy6kA/IsFL3fS+2
 /UUQvtYuPWazQ4Fi4o0Hzg+zFybcZJCndMTvzdA8qQyaZXVqgnd5nxECjVkfy4EW2Nz6
 pR2A==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=QbxjEEbfeiMzamdYCZoFeEELJ/GH0lJF8H6HQ+hOaxM=;
 b=Egqzn7N+NStbZ+Q6cYIlcNkA8bE3OlY/6bsdwCwUgAxZhU/zIPfYqPUqN/0m2PYd9F
 /5xFvp7mf4ml+z2UCzdN3Db747Idwks5g8P410iEyHGbFQ6lbl1R+DElhOiDrDQnq/cO
 d6LNdUF96QWbYyxrrhAKJA0GCt3dj18f8PUEaXKF8YCC7uHf2CI4X/kMh6Op55mN/LQ6
 TQAQCtqIRA0b0sd9I/jHWpiKeDsWf0INsL8uipceITunFi4UE+YEyxpfQ2Q8gkmuGS26
 HPODYfWOsehvI3tS7yXeLZ9VJOKML50Mx1/tiVXRfztgmt3dbrwGTxtGi1oKB9EpKhZY
 raYg==
X-Gm-Message-State: AOAM532C9gNyrf9i/79y6xRKp8esTd5vSabCrM5HXZeqAWtBZNFvFV3x
 KjnlSiUvxQUsQnoWK9doqXzVuU2IhYgU5/JN2roY3VjGhj8RJUCQ
X-Google-Smtp-Source: ABdhPJy7g/M7Kh8EiZME98ZxKdSslP6MGMaK15v0EFDvwjhikEqwwTO0MtYJyeQ4rGfwFZEhGe4DcsUTp8kBlgiUVCI=
X-Received: by 2002:a05:620a:126d:: with SMTP id
 b13mr7613105qkl.436.1620748649802; 
 Tue, 11 May 2021 08:57:29 -0700 (PDT)
MIME-Version: 1.0
References: <87im3r81so.fsf@HIDDEN>
 <78cfb495305fb1137da26e37a7ae5dd9467043bf.camel@HIDDEN>
In-Reply-To: <78cfb495305fb1137da26e37a7ae5dd9467043bf.camel@HIDDEN>
From: Andrew Tropin <andrew@HIDDEN>
Date: Tue, 11 May 2021 18:57:18 +0300
Message-ID: <CABrWRW3bRnP+vMu6j73o=p2GHbOsLQ-2MejDV5bCNFuqLDD9Sw@HIDDEN>
Subject: Re: Emacs' describe-package doesn't work for packages managed by guix
To: Leo Prikler <leo.prikler@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 48331
Cc: 48331 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

> The problem here is, that Guix does not include the <package>-pkg.el
> file, that would typically be generated by package.el.  To deal with
> this, you have to provide package specs on your own.  There already
> exists a utility to locate libraries in a package manager agnostic
> fashion [1], all you need to do is to feed back that information to
> package.el.

Yep, I figured it out yesterday and even hacked around a little bit.

Patched emacs-build-system to place packages under elpa/NAME-VERSION
subdirectory and removed "-pkg\\.el$" from %default-exclude.

> I have now published emacs-dpd [2], which does exactly that.  To use it
> for your Guix Emacs packages, execute
>   (dpd (list "$GUIX_PROFILE/share/emacs/site-lisp" ...))
> replacing "$GUIX_PROFILE" with the actual profile, after `package-
> initialize' has run with `dpd-fuzzy-recognize' in `dpd-recognize-hook'.
> I might write a more detailed README later.

Most of the packages already have -pkg.el in sources, but yep, pretty
cool utility, also thought about implementing something like that
yesterday, but luckily I didn't and now I do not need to do it, because
now I'm aware of already-existing implementations!)

> Neither packed nor dpd are currently packaged in Guix.  packed can
> easily be imported from melpa-stable, but for dpd you'd have to write
> your own guix.scm.  I might do that at some point as well.

> We already had modifications in emacs-build-system recently, so if you
> want to argue, that all Emacs packages should have that <package>-
> pkg.el to work with package.el out of the box, I would ask you to wait,
> so as to not cause an "Emacs world" rebuild again after only ten days.
> I also don't know whether Guix has the same information as package.el
> at build time, but that might change with time as well.  Particularly,
> there will hopefully be a move towards supplying name and version at
> build, which would give us the most important information.

Very cool, I didn't have the latest changes on my local checkout and didn't
see your commits, but now I see, it is exactly what I needed.

The only side note: it should be site-lisp/elpa/NAME-VERSION (right now
it is site-lisp/NAME-VERSION).  Also, on line 137 elpa-directory
function can be used.

When you will be updating the path, please remove -pkg.el from
%default-exclude.

Thank you very much for your work!  Really appreciate it!

-- 
Best regards,
Andrew Tropin




Information forwarded to bug-guix@HIDDEN:
bug#48331; Package guix. Full text available.

Message received at 48331 <at> debbugs.gnu.org:


Received: (at 48331) by debbugs.gnu.org; 11 May 2021 10:06:04 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue May 11 06:06:04 2021
Received: from localhost ([127.0.0.1]:35054 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lgPHA-0004oB-Ft
	for submit <at> debbugs.gnu.org; Tue, 11 May 2021 06:06:04 -0400
Received: from mailrelay.tugraz.at ([129.27.2.202]:34758)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <leo.prikler@HIDDEN>) id 1lgPH8-0004nj-Ct
 for 48331 <at> debbugs.gnu.org; Tue, 11 May 2021 06:06:03 -0400
Received: from [10.0.0.4] (91-114-247-246.adsl.highway.telekom.at
 [91.114.247.246])
 by mailrelay.tugraz.at (Postfix) with ESMTPSA id 4FfYTd2xwnz3xqm;
 Tue, 11 May 2021 12:05:57 +0200 (CEST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=tugraz.at;
 s=mailrelay; t=1620727557;
 bh=9aAW5k7UpkYk1kSTYFKkkdPFAidrBlLqaFYuDxxCIzs=;
 h=Subject:From:To:Date:In-Reply-To:References;
 b=DaC4iMXD4gKUaxLTU3jinahl6K2+d+EpnfJMwTnFA/lHv9rBT2EwHQD28Ao/SxLvs
 kKMZXADMFEdtS+ObT2VHzwpIDqKirlROUiU2EuKt+ua8W/rfbPjKWPDMKk/f1xBIqy
 Fu/MUVxlQ5EirTnRebAAT+k8gBXMsv/u/yut7V/U=
Message-ID: <78cfb495305fb1137da26e37a7ae5dd9467043bf.camel@HIDDEN>
Subject: Re: Emacs' describe-package doesn't work for packages managed by guix
From: Leo Prikler <leo.prikler@HIDDEN>
To: Andrew Tropin <andrew@HIDDEN>, 48331 <at> debbugs.gnu.org
Date: Tue, 11 May 2021 12:05:31 +0200
In-Reply-To: <87im3r81so.fsf@HIDDEN>
References: <87im3r81so.fsf@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
User-Agent: Evolution 3.34.2 
MIME-Version: 1.0
Content-Transfer-Encoding: 7bit
X-TUG-Backscatter-control: bt4lQm5Tva3SBgCuw0EnZw
X-Spam-Scanner: SpamAssassin 3.003001 
X-Spam-Score-relay: -1.9
X-Scanned-By: MIMEDefang 2.74 on 129.27.10.117
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 48331
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Am Montag, den 10.05.2021, 10:51 +0300 schrieb Andrew Tropin:
> describe-package and list-packages do not show emacs packages,
> installed
> with guix. Packages themselves work perfectly fine, but not listed in
> list-packages and can't be accessed with describe-package.
> 
> Way to reproduce:
> 
> guix environment --pure --ad-hoc emacs emacs-treemacs
> 
> emacs -q
> 
> M-x treemacs ;; Works fine
> C-h P treemacs ;; Doesn't work
> M-x list-packages ;; Doesn't list treemacs
> 
> Played around with it a little bit, still not sure how to solve.
This mail brought me back to the good old days of 2018, when I was
still using Gentoo and had to solve a similar issue.

The problem here is, that Guix does not include the <package>-pkg.el
file, that would typically be generated by package.el.  To deal with
this, you have to provide package specs on your own.  There already
exists a utility to locate libraries in a package manager agnostic
fashion [1], all you need to do is to feed back that information to
package.el.

I have now published emacs-dpd [2], which does exactly that.  To use it
for your Guix Emacs packages, execute 
  (dpd (list "$GUIX_PROFILE/share/emacs/site-lisp" ...))
replacing "$GUIX_PROFILE" with the actual profile, after `package-
initialize' has run with `dpd-fuzzy-recognize' in `dpd-recognize-hook'. 
I might write a more detailed README later.

Neither packed nor dpd are currently packaged in Guix.  packed can
easily be imported from melpa-stable, but for dpd you'd have to write
your own guix.scm.  I might do that at some point as well.

We already had modifications in emacs-build-system recently, so if you
want to argue, that all Emacs packages should have that <package>-
pkg.el to work with package.el out of the box, I would ask you to wait,
so as to not cause an "Emacs world" rebuild again after only ten days. 
I also don't know whether Guix has the same information as package.el
at build time, but that might change with time as well.  Particularly,
there will hopefully be a move towards supplying name and version at
build, which would give us the most important information.

Regards,
Leo

[1] https://github.com/emacscollective/packed
[2] https://gitlab.com/leoprikler/emacs-dpd





Information forwarded to bug-guix@HIDDEN:
bug#48331; Package guix. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 10 May 2021 07:51:17 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon May 10 03:51:16 2021
Received: from localhost ([127.0.0.1]:57293 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lg0hA-0004bm-OU
	for submit <at> debbugs.gnu.org; Mon, 10 May 2021 03:51:16 -0400
Received: from lists.gnu.org ([209.51.188.17]:57176)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <andrew@HIDDEN>) id 1lg0h6-0004bc-SK
 for submit <at> debbugs.gnu.org; Mon, 10 May 2021 03:51:15 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:42972)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <andrew@HIDDEN>) id 1lg0h6-0001fV-Gb
 for bug-guix@HIDDEN; Mon, 10 May 2021 03:51:12 -0400
Received: from mail-lj1-x235.google.com ([2a00:1450:4864:20::235]:42732)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_128_GCM_SHA256:128)
 (Exim 4.90_1) (envelope-from <andrew@HIDDEN>) id 1lg0h3-000595-5u
 for bug-guix@HIDDEN; Mon, 10 May 2021 03:51:12 -0400
Received: by mail-lj1-x235.google.com with SMTP id w4so19627876ljw.9
 for <bug-guix@HIDDEN>; Mon, 10 May 2021 00:51:08 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=trop-in.20150623.gappssmtp.com; s=20150623;
 h=from:to:subject:date:message-id:mime-version;
 bh=r4/sErCH6hHGhqiwJMA1i89tk3kQPD/qQIL1QSC03b0=;
 b=kLqJItH3MR5LMLLnGGmxL7x1uCiG2IqbD3XjrxTvJmpYcr0igguPHicYswWsYMg4FW
 YnCe9cFKeFOhemeGDDh7L7gZ+N39p3K5NpzU8BlEDW6M8hkjzSqQujx2EBPMsDx+8CGN
 h1+sr+gL3HpqPC2gmkVZmexzUteItHlTVmNFd7Ofx5CyYOqqzo/AVg3GNCWBQkok176Q
 rCATXfVfILU2SvbsdiUc3IPvNalc4LUZyXbGWo9Unl+n6DKRkSx6IhDyOPmxw06fSzJk
 77OOz6wQmE8YJ9IcTjnLJiqvbGveGTQtjpZks4qkkIgeoIfOVzeIU7QhyBKxSgX4ZBbQ
 W+ww==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:subject:date:message-id:mime-version;
 bh=r4/sErCH6hHGhqiwJMA1i89tk3kQPD/qQIL1QSC03b0=;
 b=WJkoIb5gSiu/SvycyabH763CEF4REN0v63kjroDoILF5NtlKbwfKIDBpDATLdOw7Cg
 PCx0eAlHPL8aQykwgvxRsPTxnRxxcSqR05qYc+cyouZFr7KRzjMQAVGRhS4SBvmlDQss
 HeivZK854rkbQXxUvHs+c8PJchrMSD1hPkTuRsE6cYghu06iaN+y9SSGVJWJM7Ycw7qW
 Yj+zKTbYmTBIsnnvLscRWfiMzEgT9ZLbKx0Q8WKCHrfmW1Cwe0SrpeVcq2KExVq1rO9z
 72QSFGwKMq+kax4yr9z+mc8zhTBzBtuXLr1mFAHfpndRgSGpBiJhxkcMmU45brWKpWBI
 MUwA==
X-Gm-Message-State: AOAM531rrTVexP4BayxyI0SV87mETmLDo5cCsRagaQFhwm/lzuQNptGw
 GKkbUWIN1f+L/cwDNqT+DJepbuDLMTiElwG1
X-Google-Smtp-Source: ABdhPJyxPoyh0kQXSEIVUWeXaIMwY9wK5FFmQmF0xef+t6WV+BbZPTbSMajTIqDvN6GneNSaocUkPQ==
X-Received: by 2002:a2e:bf1f:: with SMTP id c31mr19226507ljr.30.1620633065906; 
 Mon, 10 May 2021 00:51:05 -0700 (PDT)
Received: from ixy ([109.252.117.148])
 by smtp.gmail.com with ESMTPSA id m1sm2149567lfq.19.2021.05.10.00.51.04
 for <bug-guix@HIDDEN>
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Mon, 10 May 2021 00:51:05 -0700 (PDT)
From: Andrew Tropin <andrew@HIDDEN>
To: bug-guix@HIDDEN
Subject: Emacs' describe-package doesn't work for packages managed by guix
Date: Mon, 10 May 2021 10:51:03 +0300
Message-ID: <87im3r81so.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
Received-SPF: none client-ip=2a00:1450:4864:20::235;
 envelope-from=andrew@HIDDEN; helo=mail-lj1-x235.google.com
X-Spam_score_int: -18
X-Spam_score: -1.9
X-Spam_bar: -
X-Spam_report: (-1.9 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, RCVD_IN_DNSWL_NONE=-0.0001, SPF_HELO_NONE=0.001,
 SPF_NONE=0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

describe-package and list-packages do not show emacs packages, installed
with guix. Packages themselves work perfectly fine, but not listed in
list-packages and can't be accessed with describe-package.

Way to reproduce:

guix environment --pure --ad-hoc emacs emacs-treemacs

emacs -q

M-x treemacs ;; Works fine
C-h P treemacs ;; Doesn't work
M-x list-packages ;; Doesn't list treemacs

Played around with it a little bit, still not sure how to solve.




Acknowledgement sent to Andrew Tropin <andrew@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-guix@HIDDEN. Full text available.
Report forwarded to bug-guix@HIDDEN:
bug#48331; Package guix. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Thu, 20 May 2021 12:30:01 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.